/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CRITAVAFINAL                                             */
/* Tabela : CRITAVAFINAL                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 18/02/2003 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CRITAVAFINAL
BEFORE INSERT OR UPDATE OR DELETE
ON CRITAVAFINAL FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCTAF := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCRITAVAFIN,0) <> NVL(:NEW.CDCRITAVAFIN,0)) OR
         (NVL(:OLD.NMCRITAVAFIN,0) <> NVL(:NEW.NMCRITAVAFIN,0)) THEN
         :NEW.DTULTATUCTAF := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CRITAVAFINAL', '', 'CDTIPAUDIT='||:OLD.CDTIPAUDIT||';CDCRITAVAFIN='||:OLD.CDCRITAVAFIN||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CRITAVAFINAL MODIFY DTULTATUCTAF DEFAULT SYSDATE
/
