var Lib00207_PosicaoEstoque_Controller = function(ScreenService,ZHPromise,metaDataFactory,Lib00207_PosicaoEstoque_Service,eventEngine) {

    
    this.posicaoEstoque = function(widget, rowItem) {
        var rowParent = rowItem;
        var popUp = this.getPosicaoDeEstoquePopUpObject();
        popUp.label = popUp.defaultLabel + rowItem.NMPRODUTO;
        
        if(!(rowParent.CDFILIAL && rowParent.CDPRODUTO && rowParent.CDARVPROD && rowParent.NMPRODUTO)){
            console.error('Row do Item incompleta');
        }
        else {
          this.openPosicaoDeEstoque(widget, rowItem);
        }
    };
    
    this.openPosicaoDeEstoque = function(parentWidget, rowItem) {
        var widget = this.getPosicaoDeEstoquePopUpObject();
        widget.container = parentWidget.container;
        widget = metaDataFactory.widgetFactory(widget,parentWidget);
        parentWidget.PosEstoq = widget;
        widget.parent = parentWidget;
        widget.currentRow = rowItem;
        widget.label = widget.defaultLabel + rowItem.NMPRODUTO;
		ScreenService.openPopup(widget);
        this.getDataForPosicaoDeEstoquePopup(widget);
    };
    
    this.getPosicaoDeEstoquePopUpObject = function() {
    	return {
            "name": "posestPopup",
            "defaultLabel": "Posição de Estoque do Produto ",
            "template": "widget/form.html",
            "isVisible": true,
            "showAsTab": false,
            "actions": [
                {
                    "name": "back",
                    "label": "Voltar",
                    "showAsAction": "back",
                    "isVisible": true,
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "ScreenService.closePopup()"
                        }
                    ]
                },
                {
                    "name": "refresh",
                    "label": "Atualizar",
                    "showAsAction": "never",
                    "isVisible": true,
                    "events": [
                        {
                            "name": "ActionEvent",
                            "code": "Lib00207_PosicaoEstoque_Controller.getDataForPosicaoDeEstoquePopup(args.owner.widget)"
                        }
                    ]
                }
            ],
            "fields": [
                {
                    "name": "CDALMOXARIFE",
                    "label": "Almoxarifado",
                    "isVisible": true,
                    "readOnly": true,
                    "template": "field/text-edit.html",
                    "class": 6,
                    "showOnForm": true,
                    "events": []
                },
                {
                    "name": "CDLOCALESTOQ",
                    "label": "Localização",
                    "isVisible": true,
                    "readOnly": true,
                    "template": "field/text-edit.html",
                    "class": 6,
                    "showOnForm": true,
                    "events": []
                },
                {
                    "name": "NRLOTEESTQ",
                    "label": "Lote",
                    "isVisible": true,
                    "readOnly": true,
                    "template": "field/text-edit.html",
                    "class": 6,
                    "showOnForm": true,
                    "events": []
                },
                {
                    "name": "NRSUBLOTE",
                    "label": "Sublote",
                    "isVisible": true,
                    "readOnly": true,
                    "template": "field/text-edit.html",
                    "class": 6,
                    "showOnForm": true,
                    "events": []
                },
                {
                    "name": "QTESTOQDIA",
                    "label": "Quantidade",
                    "isVisible": true,
                    "readOnly": true,
                    "template": "field/text-edit.html",
                    "class": 6,
                    "showOnForm": true,
                    "events": []
                },
                {
                    "name": "DTVALILOTE",
                    "label": "Data de Validade",
                    "isVisible": true,
                    "sequenceInForm": 80,
                    "readOnly": true,
                    "defaultValue": null,
                    "template": "field/calendar.html",
                    "dateFormat": "DD/MM/YYYY",
                    "class": 6,
                    "showOnForm": true,
                    "events": []
                }
            ]
        };
    };
    
    this.getDataForPosicaoDeEstoquePopup = function(popup) {
    	Lib00207_PosicaoEstoque_Service.getPosicaoDeEstoquePorProduto(popup.currentRow).then(function(posestdia) {
    		if(posestdia) {
	    		popup.currentRow = posestdia;
	    		popup.parent.currentRow.QTESTOQDIA = posestdia.QTESTOQDIA;
    		}
    	}).catch(function(error) {
    		ScreenService.showMessage(error.data.error);
    	});
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register('Lib00207_PosicaoEstoque_Controller', Lib00207_PosicaoEstoque_Controller);
});